/********************************** (C) COPYRIGHT *******************************
 * File Name          : CH58x_SYS.h
 * Author             : WCH
 * Version            : V1.2
 * Date               : 2021/11/17
 * Description        : head file(ch585/ch584)
 *********************************************************************************
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * Attention: This software (modified or not) and binary are used for 
 * microcontroller manufactured by Nanjing Qinheng Microelectronics.
 *******************************************************************************/

#ifndef __CH58x_SYS_H__
#define __CH58x_SYS_H__

#ifdef __cplusplus
extern "C" {
#endif

typedef void (*MachineMode_Call_func)(void);

/**
 * @brief  rtc interrupt event define
 */
typedef enum
{
    RST_STATUS_SW = 0, // λ
    RST_STATUS_RPOR,   // ϵ縴λ
    RST_STATUS_WTR,    // Źʱλ
    RST_STATUS_MR,     // ⲿֶλ
    RST_STATUS_LRM0,   // Ѹλ-λ
    RST_STATUS_GPWSM,  // µģʽѸλ
    RST_STATUS_LRM1,   //	Ѹλ-Ź
    RST_STATUS_LRM2,   //	Ѹλ-ֶλ

} SYS_ResetStaTypeDef;

/**
 * @brief  rtc interrupt event define
 */
typedef enum
{
    INFO_ROM_READ = 0, // FlashROM  Ƿɶ
    INFO_RESET_EN = 2, // RST#ⲿֶλ빦Ƿ
    INFO_BOOT_EN,      // ϵͳ BootLoader Ƿ
    INFO_DEBUG_EN,     // ϵͳԽӿǷ
    INFO_LOADER,       // ǰϵͳǷBootloader 
    STA_SAFEACC_ACT,   // ǰϵͳǷڰȫ״̬RWA򲻿ɷ

} SYS_InfoStaTypeDef;

/**
 * @brief  ȡоƬID࣬һΪ̶ֵ
 */
#define SYS_GetChipID()      R8_CHIP_ID

/**
 * @brief  ȡȫIDһΪ̶ֵ
 */
#define SYS_GetAccessID()    R8_SAFE_ACCESS_ID

/**
 * @brief   ϵͳʱ
 *
 * @param   sc      - ϵͳʱԴѡ refer to SYS_CLKTypeDef
 */
void SetSysClock(SYS_CLKTypeDef sc);

/**
 * @brief   עеģʽִкڻеģʽµ
 *
 * @param   func    -   ڻеģʽִеĺ
 */
void MachineMode_Call(MachineMode_Call_func func);

/**
 * @brief  ʹԤȡָ
 */
void SYS_EnablePI(void);

/**
 * @brief   ȡǰϵͳʱ
 *
 * @return  Hz
 */
uint32_t GetSysClock(void);

/**
 * @brief   ȡǰϵͳϢ״̬
 *
 * @param   i       - refer to SYS_InfoStaTypeDef
 *
 * @return  Ƿ
 */
uint8_t SYS_GetInfoSta(SYS_InfoStaTypeDef i);

/**
 * @brief   ȡϵͳϴθλ״̬
 *
 * @return  refer to SYS_ResetStaTypeDef
 */
#define SYS_GetLastResetSta()    (R8_RESET_STATUS & RB_RESET_FLAG)

/**
 * @brief   ִϵͳλ
 */
void SYS_ResetExecute(void);

/**
 * @brief   øλĴֵֶλ λ ŹλͨѸλӰ
 *
 * @param   i       - refer to SYS_InfoStaTypeDef
 */
#define SYS_ResetKeepBuf(d)    (R8_GLOB_RESET_KEEP = d)

/**
 * @brief   رжϣǰжֵ
 *
 * @param   pirqv   - ǰжֵ
 */
void SYS_DisableAllIrq(uint32_t *pirqv);

/**
 * @brief   ָ֮ǰرյжֵ
 *
 * @param   irq_status  - ǰжֵ
 */
void SYS_RecoverIrq(uint32_t irq_status);

/**
 * @brief   ȡǰϵͳ(SYSTICK)ֵ
 *
 * @return  ǰֵ
 */
uint32_t SYS_GetSysTickCnt(void);

/**
 * @brief   ؿŹֵ
 *
 * @param   c       - Źֵ
 */
#define WWDG_SetCounter(c)    (R8_WDOG_COUNT = c)

/**
 * @brief   Źʱжʹ
 *
 * @param   s       - Ƿж
 */
void WWDG_ITCfg(FunctionalState s);

/**
 * @brief   Źʱλ
 *
 * @param   s       - Ƿλ
 */
void WWDG_ResetCfg(FunctionalState s);

/**
 * @brief   ȡǰŹʱ־
 *
 * @return  Źʱ־
 */
#define WWDG_GetFlowFlag()    (R8_RST_WDOG_CTRL & RB_WDOG_INT_FLAG)

/**
 * @brief   Źжϱ־¼ؼֵҲ
 */
void WWDG_ClearFlag(void);

/**
 * @brief   uS ʱ
 *
 * @param   t       - ʱ
 */
void mDelayuS(uint16_t t);

/**
 * @brief   mS ʱ
 *
 * @param   t       - ʱ
 */
void mDelaymS(uint16_t t);

/**
 * @brief Enter safe access mode.
 * 
 * @NOTE: After enter safe access mode, about 16 system frequency cycles 
 * are in safe mode, and one or more secure registers can be rewritten 
 * within the valid period. The safe mode will be automatically 
 * terminated after the above validity period is exceeded.
 *  if sys_safe_access_enable() is called,
 *  you must call sys_safe_access_disable() before call sys_safe_access_enable() again.
 */
#define sys_safe_access_enable()        do{volatile uint32_t mpie_mie;mpie_mie=__risc_v_disable_irq();SAFEOPERATE;\
                                        R8_SAFE_ACCESS_SIG = SAFE_ACCESS_SIG1;R8_SAFE_ACCESS_SIG = SAFE_ACCESS_SIG2;SAFEOPERATE;

#define sys_safe_access_disable()       R8_SAFE_ACCESS_SIG = 0;__risc_v_enable_irq(mpie_mie);SAFEOPERATE;}while(0)

#ifdef __cplusplus
}
#endif

#endif // __CH58x_SYS_H__
