#ifndef  __BSP_ML307R_H__
#define __BSP_ML307R_H__


#include "CH58x_common.h"

/*4G ģ*/
#define ENABLE_3_8_V    GPIO_Pin_3 //PB3

#define USIM_DECT_PIN GPIO_Pin_5    //PB5
#define ML307_PWR_PIN GPIO_Pin_6    //PB6
#define ML307_RST_PIN GPIO_Pin_7    //PB7

#define ML307_UART_TX_PIN   GPIO_Pin_13 //PB13
#define ML307_UART_RX_PIN  GPIO_Pin_12  //PB12



typedef struct __attribute__((packed))
{
    uint8_t module_init_flag :  1;    //ģʼ
    uint8_t Date_Sending_flag :  1;   //ݷ
    uint8_t Low_Voltage_flag :  1;    //͵ѹ
    uint8_t Key_Finish_flag :  1;     //

    uint8_t PowerOn_success_flag : 1; //ģ鿪ɹ
    uint8_t PowerOn_error_flag : 1;   //ģ鿪ʧ
    uint8_t PowerOff_success_flag : 1;//ģػɹ
    uint8_t PowerOff_error_flag : 1;  //ģػʧ

    uint8_t restart_success_flag : 1; //ģɹ
    uint8_t restart_error_flag : 1;   //ģʧ
    uint8_t sim_success_flag : 1;     //simɹ
    uint8_t sim_error_flag : 1;       //simʧ

    uint8_t Get_ModInfo_flag : 1;     //ȡģϢ
    uint8_t ModInfo_update_flag : 1;  //Ϣ
    uint8_t ModInfo_success_flag : 1; //ȡģϢɹ
    uint8_t ModInfo_error_flag : 1;   //ȡģϢʧ
    
    uint8_t Connect_success_flag : 1; //ƽ̨ɹ
    uint8_t Connect_error_flag : 1;   //ƽ̨ʧ
    uint8_t Valve_Open_flag : 1;      //Ŵ
    uint8_t Valve_Close_flag : 1;     //Źر

    uint8_t send_complete_flag : 1;   //ɱ־
    uint8_t send_error_flag : 1;      //ݴ־
    uint8_t update_time_flag : 1;     //ʱ־λ
    uint8_t login_status_flag : 1;    //¼־λ

    uint8_t Loop_count_flag : 3;      //ѭ־λ
    uint8_t Iot_Retry_flag : 1;       //Ա־λ

}IotFlagStruct;


// Module parameters
typedef struct __attribute__((packed))
{
    char cmdtype[3];
    char servic_id[5];
    char payload_len[5];
    char imei_len[5];
    char imei[60];
    char imsi_len[5];
    char imsi[60];
    char iccid_len[5];
    char iccid[60];
    char heartbeat_time_len[5];
    char heartbeat_time[9];// 0~100
    char manufacturer_name_len[5];
    char manufacturer_name[40];// 
    char terminal_type_len[5];
    char terminal_type[25];//ն
    char hardware_version_len[5];
    char hardware_version[11];//Ӳ汾
    char software_version_len[5];
    char software_version[11];//汾
    char battery_value[9];//صѹ0~5
    char battery_voltage[9];//ص  1-100

} TsModule_Info_t;

// Network service information
typedef struct
{
    char cmdtype[3];
    char servic_id[5];
    char payload_length[5];
    char rat[16];//߽͡ģʽ
    char rsrp[16];//ͣοźŽչʣ-1400~-440Чֵλ-32768
    char rssi[16];//Σյźǿָʾ -1330~-250Чֵ-32768
    char tx_power[32];//Σһεķ͹ʣ-400~230Чֵ-32768
    char tx_time[16];//ͣۼƵķʱλmsЧֵΪ0
    char rx_time[16];//ͣۼƵĽʱλmsЧֵ0
    char last_cellid[16];//ʮַһSIB1СϢʮ28BITcellid,ЧֵΪ0~0xFFFFFFE,ЧֵΪ0xFFFFFFFF
    char last_ecl[16];//͡һεECLֵͨǻǿǣЧֵȡ012
    char last_sinr[16];//ΡһεSINRֵЧֵΪ-180~-300ЧֵΪ-32768
    char last_earfcn[16];//ΣһεEARFCNֵӦǰСƵţЧֵΪ0~68535ЧֵΪ-1
    char last_pci[16];//ΣһεPICֵӦǰСIDЧֵΪ0-503ЧֵΪ65535
    char rsrq[16];//ͣοźŽ-195~-30Чֵ-32768

}Ts_Network_Service_Info_t;

extern IotFlagStruct  IotFlag_t;
extern struct tm Network_Time_t;


static void BSP_Ml307_Power_Off(void);


void BSP_Ml307r_Init(void);
void Iot_Send_Data(void);
void Ml307r_Loop(void);
void BSP_Module_Emergency_Send(uint8_t* data, uint8_t len);
void BSP_ML307_StartTimeoutTimer(void);
void BSP_ML307_SetActive(void);
void BSP_ML307_SendMessage(void);
static void BSP_Read_Module(void);
static void BSP_simcom_init(void);
static void BSP_Get_Module_Info(void);
static void BSP_Module_Connect_CtWing(void);
#endif //!@__BSP_ML307R_H__




